scala.collection.mutable

# HashTable

#### trait HashTable[A, Entry >: Null <: HashEntry[A, Entry]] extends HashUtils[A]

This class can be used to construct data structures that are based on hashtables. Class `HashTable[A]` implements a hashtable that maps keys of type `A` to values of the fully abstract member type `Entry`. Classes that make use of `HashTable` have to provide an implementation for `Entry`.

There are mainly two parameters that affect the performance of a hashtable: the initial size and the load factor. The size refers to the number of buckets in the hashtable, and the load factor is a measure of how full the hashtable is allowed to get before its size is automatically doubled. Both parameters may be changed by overriding the corresponding values in class `HashTable`.

A

  type of the elements contained in this hash table.

Source
  HashTable.scala
Version

  2.0, 31/12/2006

Since

  1

Linear Supertypes
HashUtils[A], AnyRef, Any
Known Subclasses
HashMap, LinkedHashMap, LinkedHashSet, ParHashMap, ParHashTable
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. HashTable
2. HashUtils
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Abstract Value Members

1. #### abstract def createNewEntry[B](key: A, value: B): Entry

   Creates new entry to be immediately inserted into the hashtable.

   Creates new entry to be immediately inserted into the hashtable. This method is guaranteed to be called only once and in case that the entry will be added. In other words, an implementation may be side-effecting.

   Attributes
     protected

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from HashTable[A, Entry] to any2stringadd[HashTable[A, Entry]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (HashTable[A, Entry], B)

   Implicit information
     This member is added by an implicit conversion from HashTable[A, Entry] to ArrowAssoc[HashTable[A, Entry]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### var _loadFactor: Int

   Attributes
     protected

7. #### def addEntry(e: Entry): Unit

   Add entry to table pre: no entry with same key exists

   Add entry to table pre: no entry with same key exists

   Attributes
     protected
   Annotations
     @deprecatedOverriding( ... , "2.11.0" )

8. #### def alwaysInitSizeMap: Boolean

   Attributes
     protected

9. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

10. #### def calcSizeMapSize(tableLength: Int): Int

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

11. #### def clearTable(): Unit

    Remove all entries from table

    Remove all entries from table

    Attributes
      protected

12. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

13. #### def elemEquals(key1: A, key2: A): Boolean

    Attributes
      protected

14. #### def elemHashCode(key: A): Int

    Attributes
      protected
    Definition Classes
      HashUtils

15. #### def ensuring(cond: (HashTable[A, Entry]) ⇒ Boolean, msg: ⇒ Any): HashTable[A, Entry]

    Implicit information
      This member is added by an implicit conversion from HashTable[A, Entry] to Ensuring[HashTable[A, Entry]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: (HashTable[A, Entry]) ⇒ Boolean): HashTable[A, Entry]

    Implicit information
      This member is added by an implicit conversion from HashTable[A, Entry] to Ensuring[HashTable[A, Entry]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean, msg: ⇒ Any): HashTable[A, Entry]

    Implicit information
      This member is added by an implicit conversion from HashTable[A, Entry] to Ensuring[HashTable[A, Entry]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: Boolean): HashTable[A, Entry]

    Implicit information
      This member is added by an implicit conversion from HashTable[A, Entry] to Ensuring[HashTable[A, Entry]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def entriesIterator: Iterator[Entry]

    An iterator returning all entries.

    An iterator returning all entries.

    Attributes
      protected

20. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

21. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

22. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

23. #### def findEntry(key: A): Entry

    Find entry with given key in table, null if not found.

    Find entry with given key in table, null if not found.

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

24. #### def findOrAddEntry[B](key: A, value: B): Entry

    Find entry with given key in table, or add new one if not found.

    Find entry with given key in table, or add new one if not found. May be somewhat faster then `findEntry`/`addEntry` pair as it computes entry's hash index only once. Returns entry found in table or null. New entries are created by calling `createNewEntry` method.

    Attributes
      protected

25. #### def foreachEntry[U](f: (Entry) ⇒ U): Unit

    Avoid iterator for a 2x faster traversal.

    Avoid iterator for a 2x faster traversal.

    Attributes
      protected

26. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from HashTable[A, Entry] to StringFormat[HashTable[A, Entry]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

27. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

28. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

29. #### final def improve(hcode: Int, seed: Int): Int

    Attributes
      protected
    Definition Classes
      HashUtils

30. #### final def index(hcode: Int): Int

    Attributes
      protected

31. #### def initWithContents(c: Contents[A, Entry]): Unit

    Attributes
      protected

32. #### def initialSize: Int

    The initial size of the hash table.

    The initial size of the hash table.

    Attributes
      protected

33. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

34. #### def isSizeMapDefined: Boolean

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

35. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

36. #### def nnSizeMapAdd(h: Int): Unit

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

37. #### def nnSizeMapRemove(h: Int): Unit

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

38. #### def nnSizeMapReset(tableLength: Int): Unit

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

39. #### final def notify(): Unit

    Definition Classes
      AnyRef

40. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

41. #### def removeEntry(key: A): Entry

    Remove entry from table if present.

    Remove entry from table if present.

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

42. #### var seedvalue: Int

    Attributes
      protected

43. #### final def sizeMapBucketBitSize: Int

    Attributes
      protected
    Definition Classes
      HashUtils

44. #### final def sizeMapBucketSize: Int

    Attributes
      protected
    Definition Classes
      HashUtils

45. #### def sizeMapDisable(): Unit

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

46. #### def sizeMapInit(tableLength: Int): Unit

    Attributes
      protected

47. #### def sizeMapInitAndRebuild(): Unit

    Attributes
      protected
    Annotations
      @deprecatedOverriding( ... , "2.11.0" )

48. #### var sizemap: Array[Int]

    The array keeping track of the number of elements in 32 element blocks.

    The array keeping track of the number of elements in 32 element blocks.

    Attributes
      protected

49. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

50. #### var table: Array[HashEntry[A, Entry]]

    The actual hash table.

    The actual hash table.

    Attributes
      protected

51. #### var tableSize: Int

    The number of mappings contained in this hash table.

    The number of mappings contained in this hash table.

    Attributes
      protected

52. #### def tableSizeSeed: Int

    Attributes
      protected

53. #### var threshold: Int

    The next size value at which to resize (capacity * load factor).

    The next size value at which to resize (capacity * load factor).

    Attributes
      protected

54. #### def toString(): String

    Definition Classes
      AnyRef → Any

55. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

56. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

57. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

58. #### def →[B](y: B): (HashTable[A, Entry], B)

    Implicit information
      This member is added by an implicit conversion from HashTable[A, Entry] to ArrowAssoc[HashTable[A, Entry]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from HashUtils[A]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from HashTable[A, Entry] to any2stringadd[HashTable[A, Entry]]

### Inherited by implicit conversion StringFormat from HashTable[A, Entry] to StringFormat[HashTable[A, Entry]]

### Inherited by implicit conversion Ensuring from HashTable[A, Entry] to Ensuring[HashTable[A, Entry]]

### Inherited by implicit conversion ArrowAssoc from HashTable[A, Entry] to ArrowAssoc[HashTable[A, Entry]]

### Ungrouped